//-----------------------------------------------------------------------------
// CTriPatch
//
// This is the application class that computes and renders the triangular 
// bezier patch.
//
// Copyright (c) 2000 Andreas Jnsson
//-----------------------------------------------------------------------------
#ifndef TRIPATCH_H
#define TRIPATCH_H

#include "d3dapp.h"
#include "vertex.h"

class CTriPatch : public CD3DApp
{
public:
	CTriPatch();

protected:
	virtual HRESULT Initialize(char *szCmdLine);	
	virtual HRESULT Terminate();
	virtual HRESULT UpdateScene();
	virtual HRESULT RenderScene();

    LRESULT MsgProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );

	void RenderBezier();
	void CubicBezier(CVertex P[10]);

	float m_fAngle;
	bool  m_bShowNormals;
	bool  m_bShowSurface;
	bool  m_bShowControl;

	int      m_nNumDivs;
	int      m_nNumIndices;
	int      m_nNumVertices;
	CVertex *m_pVertices;
	WORD    *m_pIndices;
};

#endif